;POSEX1                                
;                '99.4.26              
;                                      
;C4 D0 -- 2^0                          
;   D1 -- 2^1                          
;   D2 -- 2^2                          
;   D3 -- Home Serch                   
;   D4 -- READY                        
;   D5 -- START                        
;   D6 -- CCW                          
;   D7 -- CW                           
;                                      
;C5 D0 -- Home LS                      
;   D1 -- -OT                          
;   D2 -- +OT                          
;                                      
;C0 D0 -- Brake Open                   
;   D1 -- POS END                      
;                                      
;  No.0 -- 0 SETPOS (SET POS=POS/100)  
;     1 -- 1 SETPOS                    
;     2 -- 2 SETPOS                    
;     3 -- 3 SETPOS                    
;     4 -- 4 SETPOS                    
;     5 -- 5 SETPOS                    
;     6 -- 6 SETPOS                    
;     7 -- 7 SETPOS                    
;     8 -- PSG                         
;     9 -- Mun HZP                     
;    10 -- H.S HZP (Z Serch=1/10)      
;                                      
     TIC1=410                          
TM0  JNE TM0 TIC1                      
G00  CALL $460                         
     CALL $490                         
     POKE $FF02 1   ;4byte             
     NOP                               
;                                      
G10  JEQ G10 C4 AND 16  ;Ready?        
     JSR Z00                           
;                                      
G20  JNE I00 C4 AND 32  ;Start?        
     JNE H50 C4 AND 8   ;Home Serch?   
     JNE H00 C4 AND 64  ;CCW?          
     JNE H20 C4 AND 128 ;CW?           
     JNE G20 C4 AND 16  ;Ready Off?    
G22  POKE $FF00 1       ;H.P FLAG      
     JSR Z10                           
     JMP G10                           
;                                      
;----- CCW ------                      
;                                      
H00  JEQ G20 C5 AND 4   ;+OT?          
H02  DPEEK A0 $FE62     ;9 Mun HZP     
     HZP=A0                            
     JEQ H10 C5 AND 4   ;+OT?          
     JEQ G22 C4 AND 16  ;Ready Off?    
     JNE H02 C4 AND 64  ;CCW?          
     JMP H12                           
;                                      
;----- STOP -----                      
;                                      
H10  PSG=0                             
H12  HZP=0                             
H14  JNE H14 HZS                       
     POKE $FF00 1       ;Z serch OFF   
     JMP G20                           
;                                      
;----- CW -----                        
;                                      
H20  JEQ G20 C5 AND 2   ;-OT?          
H22  DPEEK A0 $FE62     ;9 Mun HZP     
     HZP=-A0                           
     JEQ H10 C5 AND 2   ;-OT?          
     JEQ G22 C4 AND 16  ;Ready Off?    
     JNE H22 C4 AND 128 ;CW?           
     JMP H12                           
;                                      
;----- Home Serch -----                
;                                      
H50  DPEEK A0 $FE64     ;10 H.S HZP    
     HZP=-A0                           
H52  JEQ H10 C5 AND 2   ;-OT?          
     JEQ G22 C4 AND 16  ;Ready Off?    
     JEQ H52 C5 AND 1   ;Home LS?      
     A0=A0/10                          
     HZP=-A0                           
     POKE $FF00 0       ;Z serch Start 
H54  JEQ G22 C4 AND 16  ;Ready Off?    
     JEQ H10 C5 AND 2   ;-OT?          
     PEEK A1 $FF00                     
     JEQ H54 A1         ;Z Serch End?  
     DPEEK AA $EF18     ;Z in PLS Hi   
     DPEEK AB $EF20     ;Z in PLS Lo   
     POS=AA                            
     JMP I01                           
;                                      
;----- POS -----                       
;                                      
I00  A2=C4 AND 7                       
     A2=A2*2                           
     A2=A2+$FE50                       
     DPEEK A0 A2                       
     DPEEK AA $EF18      ;Z in PLS Hi  
     DPEEK AB $EF20      ;Z in PLS Lo  
     AC=A0*100                         
     NOP                               
     NOP                               
     POS=AC+AA                         
I01  DPEEK A1 $FE60      ;8 PSG        
     PSG=A1                            
I02  JEQ G22 C4 AND 16   ;Ready Off?   
     JNE H10 C5 AND 6-6  ;OT?          
     JNE I02 PSG                       
     C0=C0 OR 2          ;POS END      
     TIC1=200                          
I04  JNE I04 TIC1                      
     C0=C0 AND $FD                     
     JMP G20                           
;                                      
;----- Power ON -----                  
;                                      
Z00  SEVCC=1                           
     TIC1=100                          
Z02  JNE Z02 TIC1                      
     RTS                               
;                                      
;----- Power OFF -----                 
;                                      
Z10  PSG=0                             
     HZP=0                             
Z12  JNE Z12 HZS                       
     TIC1=100                          
Z14  JNE Z14 TIC1                      
     SEVCC=0                           
     RTS                               
     END                               
