;POSEX2                                
;               '99.4.26               
;                                      
;C4 D0 --                              
;   D1 --                              
;   D2 --                              
;   D3 --                              
;   D4 -- READY                        
;   D5 -- START                        
;   D6 -- CCW                          
;   D7 -- CW                           
;                                      
;C0 D0 -- Brake Open                   
;   D1 -- POS END                      
;                                      
;  No.0 -- 0 SETPOS (SET POS=POS/100)  
;     1 -- PSG                         
;     2 -- Mun HZP                     
;                                      
     TIC1=410                          
TM0  JNE TM0 TIC1                      
G00  CALL $460                         
     CALL $490                         
     POKE $FF02 1       ;4byte         
     AA=10000                          
;                                      
G10  JEQ G10 C4 AND 16  ;Ready?        
     JSR Z00                           
;                                      
G20  JNE I00 C4 AND 32  ;Start?        
     JNE H00 C4 AND 64  ;CCW?          
     JNE H20 C4 AND 128 ;CW?           
     JNE G20 C4 AND 16  ;Ready Off?    
G22  JSR Z10                           
     JMP G10                           
;                                      
;----- CCW ------                      
;                                      
H00  DPEEK A0 $FE54     ;2 Mun HZP     
     HZP=A0                            
     JEQ G22 C4 AND 16  ;Ready Off?    
     JNE H00 C4 AND 64  ;CCW?          
;                                      
;----- STOP -----                      
;                                      
H10  HZP=0                             
H12  JNE H12 HZS                       
     JMP G20                           
;                                      
;----- CW -----                        
;                                      
H20  DPEEK A0 $FE54     ;2 Mun HZP     
     HZP=-A0                           
     JEQ G22 C4 AND 16  ;Ready Off?    
     JNE H20 C4 AND 128 ;CW?           
     JMP H10                           
;                                      
;----- POS -----                       
;                                      
I00  PLS=AA                            
     DPEEK A0 $FE50     ;0 SETPOS      
     AC=A0*100                         
     NOP                               
     NOP                               
     POS=AC+AA                         
     DPEEK A1 $FE52     ;1 PSG         
     PSG=A1                            
I02  JEQ G22 C4 AND 16  ;Ready Off?    
     JNE I02 PSG                       
     C0=C0 OR 2         ;POS END       
     TIC1=100                          
I04  JNE I04 TIC1                      
     C0=C0 AND $FD                     
     JMP G20                           
;                                      
;----- Power ON -----                  
;                                      
Z00  SEVCC=1                           
     TIC1=100                          
Z02  JNE Z02 TIC1                      
     RTS                               
;                                      
;----- Power OFF -----                 
;                                      
Z10  PSG=0                             
     HZP=0                             
Z12  JNE Z12 HZS                       
     TIC1=100                          
Z14  JNE Z14 TIC1                      
     SEVCC=0                           
     RTS                               
     END                               
