;SPDEX1                                
;                '99.4.26              
;                                      
;C4 D0 -- 2^0                          
;   D1 -- 2^1                          
;   D2 -- 2^2                          
;   D3                                 
;   D4 -- READY                        
;   D5 -- START                        
;   D6 -- CCW/CW                       
;                                      
;  No.0 -- 0 HZP  (HZP=1 = 1/32Hz)     
;     1 -- 1 HZP                       
;     2 -- 2 HZP                       
;     3 -- 3 HZP                       
;     4 -- 4 HZP                       
;     5 -- 5 HZP                       
;     6 -- 6 HZP                       
;     7 -- 7 HZP                       
     TIC1=410                          
TM0  JNE TM0 TIC1                      
G00  CALL $460                         
     CALL $490                         
     POKE $FF02 1   ;4byte             
     A0=0                              
     NOP                               
;                                      
G10  JEQ G10 C4 AND 16  ;Ready?        
     JSR Z00                           
;                                      
G20  JNE I00 C4 AND 32  ;Start?        
G21  A1=1                              
     JEQ G22 C4 AND 64  ;CW?           
     A1=-1                             
G22  HZP=A0*A1                         
;                                      
     JNE G20 C4 AND 16  ;Ready Off?    
     JSR Z10                           
     A0=0                              
     JMP G10                           
;                                      
I00  A2=C4 AND 7                       
     A2=A2*2                           
     A2=A2+$FE50                       
     DPEEK A0 A2                       
     JMP G21                           
;                                      
Z00  SEVCC=1                           
     TIC1=100                          
Z02  JNE Z02 TIC1                      
     RTS                               
;                                      
Z10  HZP=0                             
Z12  JNE Z12 HZS                       
     TIC1=100                          
Z14  JNE Z14 TIC1                      
     SEVCC=0                           
     RTS                               
     END                               
                                       
